#! /usr/bin/env python
import pygtk
pygtk.require("2.0")
import bonobo.activation
import ORBit, CORBA
from types import *
import gnumexp_conf
ORBit.load_typelib(gnumexp_conf.KERNEL_TYPELIB)

# kernel = bonobo.get_object('OAFIID:Numexp_Kernel', 'Numexp/Kernel')
kernel = bonobo.activation.activate("repo_ids.has('IDL:Numexp/Kernel:1.0')")

def _python_value_to_element(value):
    if type(value) is StringType:
	return kernel.parseString(value)
    elif type(value) is FloatType:
	return kernel.elementReal(value)
    elif type(value) is IntType:
	return kernel.elementInt(value)
    
def numexp_kernel_linear_sample(expression, variable, start, end, samples):
    expr = _python_value_to_element(expression)
    var = _python_value_to_element(variable)
    start = _python_value_to_element(start)
    end = _python_value_to_element(end)
    ignore_errors = kernel.elementInt(1);
    nsamples = kernel.elementInt(int(samples));
    ## Notice that the function element takes ownership of the
    ## references to the parameters
    func     = kernel.elementFunction("sample", [expr, var, start, end, nsamples, ignore_errors])
    el       = kernel.elementEval(func)
    res      = kernel.elementAsAny(el)
    values   = [x.value() for x in res.value()]
    kernel.elementUnref(func)
    kernel.elementUnref(el)
    return values

def numexp_kernel_adaptive_sample(expr, var, xmin, xmax, ymin, ymax, prec):
    expr = kernel.parseString(expr)
    var = kernel.parseString(var)
    xmin = _python_value_to_element(xmin)
    xmax = _python_value_to_element(xmax)
    ymin = _python_value_to_element(ymin)
    ymax = _python_value_to_element(ymax)
    prec = kernel.elementInt(prec)
    ## Notice that the function element takes ownership of the
    ## references to the parameters
    func     = kernel.elementFunction("adaptivesample", [expr, var, xmin, xmax, ymin, ymax, prec])
    el       = kernel.elementEval(func)
    res      = kernel.elementAsAny(el)
    values   = [x.value() for x in res.value()]
    kernel.elementUnref(func)
    kernel.elementUnref(el)
    return values

__all__ = ['kernel', 'numexp_kernel_linear_sample', 'numexp_kernel_adaptive_sample']


def test():
    expr = kernel.parseString("sin(x)"); print "expr: '%s'" % (kernel.elementStr(expr),)
    var = kernel.parseString("x"); print "var: '%s'" % (kernel.elementStr(var),)
    start = kernel.elementReal(1.5); print "start: '%s'" % (kernel.elementStr(start),)
    end = kernel.elementReal(11.5); print "end: '%s'" % (kernel.elementStr(end),)
    nsamples = kernel.elementInt(100); print "nsamples: '%s'" % (kernel.elementStr(nsamples),)
    func = kernel.elementFunction("sample", [expr, var, start, end, nsamples])
    print "func: '%s'" % (kernel.elementStr(func),)
    r  = kernel.elementEval(func)
    any = kernel.elementAsAny(r)
    print "any:", any
    print "typecode:", any.typecode()
    print "value:", any.value()
    print "value2:", map(lambda x: x.value(), any.value())
    rs = kernel.elementStr(r)
    print "result =", rs


if __name__ == '__main__':
    test()

