#! /usr/bin/env python
from __future__ import division
import re
import math
from nxplot import *
from types import *
from dialogs.lineattr import Color, LineAttr
from copy import *
import xml.dom.minidom as dom
import xml.sax.saxutils
import gtk.gdk
import gobject
# pymathml import
import mathml
import mathml.xml.minidom_parser as mathml_parser
import mathml.backend.nxplot_mathml as mathml_renderer
from xygraphC import ControlPoint
import xygraphC

"""
Our OS who art in CPU, UNIX be thy name.
	Thy programs run, thy syscalls done,
	In kernel as it is in user!
"""

CONTROL_POINT_SIZE = 4



class CanvasObjectBase(NxpCanvasObject):

    def real_draw(self, pl):
	pass

    def real_configure(self, new_bbox, interaction):
	pass

    def real_size_request(self):
	return NxplotPoint(0, 0)

    def real_enter(self):
	pass

    def real_leave(self):
	pass

    def real_button_press(self, event):
	pass

    def real_button_release(self, event):
	pass

    def real_motion_notify(self, event):
	pass

    def __init__(self):
	self.__gobject_init__()
	self._set_drawable(1)
	self._set_visible(1)
	self.set_property("interaction-mask", 0)
	self.connect("draw", 		self.__class__.real_draw		)
	self.connect("configure", 	self.__class__.real_configure		)
	self.connect("size-request", 	self.__class__.real_size_request	)
	self.connect("enter", 		self.__class__.real_enter		)
	self.connect("leave", 		self.__class__.real_leave		)
	self.connect("button-press", 	self.__class__.real_button_press	)
	self.connect("button-release", 	self.__class__.real_button_release	)
	self.connect("motion-notify", 	self.__class__.real_motion_notify	)

gobject.type_register(CanvasObjectBase)


class CanvasContainerBase(NxpCanvasContainer):
    # NxpCanvasObject methods
    def real_draw(self, pl):
	pass #print self, "draw()"

    def real_configure(self, new_bbox, interaction):
	pass #print self, "configure()"

    def real_size_request(self):
	#print self, "size_request()"
	return NxplotPoint(0, 0)

    def real_enter(self):
	pass #print self, "enter()"

    def real_leave(self):
	pass #print self, "leave()"

    # NxpCanvasContainer methods
    def real_get_children(self):
	pass #print self, "get_children()"

    def real_get_child_at_point(self, x, y):
	pass #print self, "get_child_at_point()"

    def real_button_press(self, event):
	pass

    def real_button_release(self, event):
	pass

    def real_motion_notify(self, event):
	pass

    # Contructor
    def __init__(self):
	self.__gobject_init__()
	self._set_drawable(1)
	self._set_visible(1)
	self.set_property("interaction-mask", 0)
	self.connect("draw", 		   self.__class__.real_draw		  )
	self.connect("configure", 	   self.__class__.real_configure	  )
	self.connect("size-request", 	   self.__class__.real_size_request	  )
	self.connect("enter", 		   self.__class__.real_enter		  )
	self.connect("leave", 		   self.__class__.real_leave		  )
	self.connect("get_children", 	   self.__class__.real_get_children	  )
	self.connect("get_child_at_point", self.__class__.real_get_child_at_point )
	self.connect("button-press", 	   self.__class__.real_button_press	  )
	self.connect("button-release", 	   self.__class__.real_button_release	  )
	self.connect("motion-notify", 	   self.__class__.real_motion_notify	  )

gobject.type_register(CanvasContainerBase)


# class ControlPoint(NxpCanvasOverlay):
#     SIZE=4
#     def __init__(self, x, y, state=1):
# 	self.__gobject_init__()
# 	self.connect("draw", self.__class__.real_draw)
# 	self.x = x; self.y = y
#         try:
#             self.set_bbox(int(x - self.SIZE/2), int(y - self.SIZE/2),
#                           self.SIZE, self.SIZE)
#         except OverflowError:
#             pass
# 	self.state = state

#     def real_draw(self, drawable, gc, t):
# 	gc.set_line_attributes(0, gtk.gdk.LINE_SOLID,
# 			       gtk.gdk.CAP_NOT_LAST, gtk.gdk.JOIN_MITER)
# 	drawable.draw_rectangle(gc, True, self.bbox.x, self.bbox.y,
# 				self.bbox.width,
# 				self.bbox.height)


class PlotObject(CanvasObjectBase):

    STATE_NORMAL = 0
    STATE_SELECTED = (1<<0)
    STATE_PRELIGHT = (1<<1)
    
    def __init__(self):
	CanvasObjectBase.__init__(self)
	self.bbox = NxplotRect(0, 0, 0, 0)
	self.set_range(0, 0, 1, 1)
	self.set_property("interaction-mask", 0)
	self.view = None
	self.control_points = []
	self.state = None
        self.lineattr = None # set by plotobject impl.
        self.outer_lineattr = None # computed by calc_state_lineattrs
        self.inner_lineattr = None # computed by calc_state_lineattrs
	self.connect("notify::canvas", self.__notify_canvas)

    def __notify_canvas(self, *args):
	self.update_control_points()
	
    def _update_range2bbox(self):
	if not self.bbox: return
	self.bbox_dx = self.bbox.x2 - self.bbox.x1
	self.bbox_dy = self.bbox.y2 - self.bbox.y1
	self.bbox_sz = math.hypot(self.bbox_dx, self.bbox_dy)
	try:
	    self.range2bbox_sx = self.bbox_dx / (self.range.x2 - self.range.x1)
	except ZeroDivisionError: pass
	try:
	    self.range2bbox_sy = self.bbox_dy / (self.range.y2 - self.range.y1)
	except ZeroDivisionError: pass
	
    def set_range(self, x1, y1, x2, y2):
	#print "PlotObject.set_range(%f, %f, %f, %f)" % (x1, y1, x2, y2)
	self.range = NxplotRect(x1, y1, x2, y2)
	self._update_range2bbox()
	self.update_control_points()

    def real_size_request(self):
	# our container doesn't care how much space we ask for
	return NxplotPoint(0, 0)

    def real_configure(self, bbox, interaction):
	assert isinstance(bbox, NxplotRect)
	self.bbox = NxplotRect(bbox.x1, bbox.y1, bbox.x2, bbox.y2)
	#print "configure: self.bbox = ", "(%f, %f, %f, %f)" % \
	#      (self.bbox.x1, self.bbox.y1, self.bbox.x2, self.bbox.y2)
	self._update_range2bbox()
	self.update_control_points()
	
    def range2bbox_x(self, x):
	return (x - self.range.x1) * self.range2bbox_sx + self.bbox.x1

    def range2bbox_y(self, y):
	return (y - self.range.y1) * self.range2bbox_sy + self.bbox.y1

    def get_values(self):
	return { 'label': self.caption,
		 'lineattr': deepcopy(self.lineattr),
		 }

    def set_values(self, values):
        self.caption = values['label']
        self.lineattr = values['lineattr']

    def to_xml(self, doc):
	assert isinstance(doc, dom.Document)
	elem = doc.createElement("plotobject")
	elem.setAttribute("label", self.caption)
	elem.appendChild(self.lineattr.to_xml(doc))
	return elem

    def from_xml(self, elem, plotarea):
	assert isinstance(elem, dom.Element)
	assert elem.tagName == 'plotobject'
	self.caption  = elem.getAttribute("label").encode()
	lineattrs = elem.getElementsByTagName('lineattr')
	if lineattrs:
	    self.lineattr = LineAttr()
	    self.lineattr.from_xml(lineattrs[0])
	else:
	    self.lineattr = plotarea.suggest_lineattr()

    def draw_legend_sample(self, pl, really_draw):
	"""Draw a small sample that identify the plot object.
	This will appear in the legend.

	If @really_draw is FALSE, the function should return the (width, height)
	of the bounding box of this sample.
	If @really_draw is TRUE, the sample should be drawn,
	enclosed in the box (0, 0)-(width, height)"""

	# This is default implementation that draws nothing.
	# Specific PlotObject's should override this.
	if not really_draw:
	    return 0, 0
	
    def draw_legend_label(self, pl, attributes, really_draw, data=None):
	"""Draw the label that identifies the plot object.
	This will appear in the legend.

	If @really_draw is FALSE, the function should return the
	(width, descender, ascender, data) of the bounding box of this
	sample plus any data that it wishes to save until rendering
	time.
	
	If @really_draw is TRUE, the label should be drawn,
	starting at (0, 0); the function should return nothing"""

	# This is default implementation that draws a simple label.
	# Specific PlotObject's may override this.
	pl.fontname(attributes.get('fontname', "Sans Regular"))
	pl.fontsize(attributes['fontsize'])
	pl.textangle(0)
	color = attributes.get('color', (0, 0, 0))
	pl.pencolor(color[0], color[1], color[2])
	if not really_draw:
	    if self.caption is None: return 0, 0, 0
	    ascender_max, descender_max, ascender, descender, width = \
			  pl.labelmetrics(self.caption)
	    return width, ascender, descender, None
	else:
	    if self.caption is None:
		caption = str(self)
	    else:
		caption = self.caption
	    pl.move(0, 0)
	    pl.label(HAlign.LEFT, VAlign.BASELINE, caption)
	

    def _draw_legend_label_mathml(self, mathml_input, pl, attributes,
				  really_draw, data=None):
	"""A variant of draw_legend_label, that receives a mathml
	string as input and renders it using nxplot_mathml """

	if not really_draw:
	    #print "Parsing MathML string:"
	    #print mathml_input
	    plotter = mathml_renderer.NxplotPlotter(pl, 72)
	    math = mathml_parser.parseString(mathml_input, plotter)
	    math.setAttribute("fontsize", str(attributes['fontsize']))
	    #mathml = nmml_parse(pl, mathml_input,
		#		{'initial_size': str(attributes['fontsize'])})
	    #width, ascender, descender = mathml.get_dimmensions()
	    math.update()
	    return math.width, math.height, 0, math
	else:
	    math = data
	    math.render()

    def _label_to_mathml(self, label, substs):
	""" Converts a label that can contain %x markers to be replaced with
	mathml content to a global mathml string.
	
	@substs: a dictionary of type {'%x': mathml code without <math>, ...}
	"""
	tokens = []
	start  = 0
	if not label: return "<math></math>"
	while 1:
	    pos = label.find("%", start)
	    if pos == -1:		# % not found
		ltok = label[start:]
		next = None
		start = len(label)
	    else:
		ltok = label[start:pos]
		try:
		    next = label[pos + 1]
		except IndexError:	# % ends the string
		    next = '%'
		start = pos + 2
	    # replace leading spaces in ltok with <mspace> tokens
	    s = ""
	    for c in ltok:
		if c != ' ': break
		s += "<mspace width='0.5em'/>"
	    text = xml.sax.saxutils.escape(ltok.strip())
	    if text:
		s += "<mtext>%s</mtext>" % text
	    # the same for the trailing spaces
	    i = -1
	    if ltok:
		while 1:
                    try:
                        c = ltok[i]
                    except IndexError:
                        break
		    i -= 1
		    if c != ' ': break
		    s += "<mspace width='0.5em'/>"
	    tokens.append(s)
	    if next is not None:
		if next == '%':
		    tokens.append("<mtext>%%</mtext>")
		else:
		    skey = '%' + next
		    try:
			subst = substs[skey]
			tokens.append(subst)
		    except KeyError:
			subst = tokens.append("<mtext>%%%s</mtext>" % next)
	    if start >= len(label): break
	return "<math>" + "".join(tokens) + "</math>"

    def get_y_range(self):
	"""Should return (ymin, ymax), the vertical range limits of
	whatever it draws, or None if not supported."""
	pass

    def get_control_points(self):
	"""Return a list of (x, y) pairs representing control points,
	in window coordinates. These control points will be painted to
	represented object selection."""
	# default empty list; specific plot object implementations
	# should override this function.
	return ()

    def update_control_points(self):
	if self.canvas is None: return
	for cp in self.control_points: cp.hide()
	self.control_points = []
	for x, y in self.get_control_points():
            try:
                cp = ControlPoint(int(x), int(y), CONTROL_POINT_SIZE)
            except OverflowError:
                cp = None
            if cp is not None:
                cp.set_canvas(self.canvas)
                self.control_points.append(cp)

    def set_control_points_visible(self, visible):
	for cp in self.control_points:
	    if visible:
		cp.show()
	    else:
		cp.hide()

    def distance_to_point(self, x, y):
	"""Computes distance of point (x, y) to the plot object.  This
	is ideally, because in practice it computes the distance from
	(x, y) to the closest control point, which is good enough."""
        return xygraphC.distance_to_point(int(x), int(y), self.control_points)

    def set_state(self, state):
	if state == self.state:
	    return
	self.state = state
        self.calc_state_lineattrs()
	self.queue_draw()

    def set_selected(self, selected):
        if selected:
            self.set_state(self.state | self.STATE_SELECTED)
        else:
            self.set_state(self.state & (~self.STATE_SELECTED))

    def set_prelight(self, prelight):
        if prelight:
            self.set_state(self.state | self.STATE_PRELIGHT)
        else:
            self.set_state(self.state & (~self.STATE_PRELIGHT))

    def calc_state_lineattrs(self):
        if self.state == self.STATE_NORMAL:
            self.inner_lineattr = self.lineattr
            self.outer_lineattr = None
        elif self.state & self.STATE_SELECTED:
            attr = deepcopy(self.lineattr)
            attr.thickness = max(attr.thickness + 15, attr.thickness*2)
            # blend the color with white
            r, g, b = attr.color.red, attr.color.green, attr.color.blue
            c = 0.85 # relative weight of white
            c1 = (1 - c)
            r = r*c1 + 0xffff*c
            g = g*c1 + 0xffff*c
            b = b*c1 + 0xffff*c
            attr.color = Color(int(r), int(g), int(b))
            attr.dash_style = Linemode.SOLID
            self.inner_lineattr = self.lineattr
            self.outer_lineattr = attr
        elif self.state & self.STATE_PRELIGHT:
            attr = deepcopy(self.lineattr)
            attr.thickness = max(attr.thickness + 5, attr.thickness*1.25)
            r, g, b = attr.color.red, attr.color.green, attr.color.blue
            # increase the brightness without changing hue
            maxcolor = max(r, g, b)
            if maxcolor == 0:
                s = 0
            else:
                s = max(1.3, 1.0 / maxcolor)
            r *= s
            g *= s
            b *= s
            # blend the color with white
            c = 0.45 # relative weight of white
            c1 = (1 - c)
            r = r*c1 + 0xffff*c
            g = g*c1 + 0xffff*c
            b = b*c1 + 0xffff*c
            attr.color = Color(int(r), int(g), int(b))
            self.inner_lineattr = attr
            self.outer_lineattr = None
        else:
            assert False, "invalid state %i!!!" % self.state

    def to_xml_string(self):
	"""Return a XML string of object representation"""

	doc = dom.Document()
	doc.appendChild(self.to_xml(doc))
	return doc.toxml()

